<?php
/*
 * Copyright 2014 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

namespace Automattic\WooCommerce\GoogleListingsAndAds\Vendor\Google\Service\ShoppingContent;

class CustomAttribute extends \Automattic\WooCommerce\GoogleListingsAndAds\Vendor\Google\Collection
{
  protected $collection_key = 'groupValues';
  protected $groupValuesType = CustomAttribute::class;
  protected $groupValuesDataType = 'array';
  public $groupValues;
  /**
   * @var string
   */
  public $name;
  /**
   * @var string
   */
  public $value;

  /**
   * @param CustomAttribute[]
   */
  public function setGroupValues($groupValues)
  {
    $this->groupValues = $groupValues;
  }
  /**
   * @return CustomAttribute[]
   */
  public function getGroupValues()
  {
    return $this->groupValues;
  }
  /**
   * @param string
   */
  public function setName($name)
  {
    $this->name = $name;
  }
  /**
   * @return string
   */
  public function getName()
  {
    return $this->name;
  }
  /**
   * @param string
   */
  public function setValue($value)
  {
    $this->value = $value;
  }
  /**
   * @return string
   */
  public function getValue()
  {
    return $this->value;
  }
}

// Adding a class alias for backwards compatibility with the previous class name.
class_alias(CustomAttribute::class, 'Google_Service_ShoppingContent_CustomAttribute');
