<?php
/*
 * Copyright 2014 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

namespace Automattic\WooCommerce\GoogleListingsAndAds\Vendor\Google\Service\ShoppingContent;

class ListAccountReturnCarrierResponse extends \Automattic\WooCommerce\GoogleListingsAndAds\Vendor\Google\Collection
{
  protected $collection_key = 'accountReturnCarriers';
  protected $accountReturnCarriersType = AccountReturnCarrier::class;
  protected $accountReturnCarriersDataType = 'array';
  public $accountReturnCarriers;

  /**
   * @param AccountReturnCarrier[]
   */
  public function setAccountReturnCarriers($accountReturnCarriers)
  {
    $this->accountReturnCarriers = $accountReturnCarriers;
  }
  /**
   * @return AccountReturnCarrier[]
   */
  public function getAccountReturnCarriers()
  {
    return $this->accountReturnCarriers;
  }
}

// Adding a class alias for backwards compatibility with the previous class name.
class_alias(ListAccountReturnCarrierResponse::class, 'Google_Service_ShoppingContent_ListAccountReturnCarrierResponse');
