<?php
/*
 * Copyright 2014 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

namespace Automattic\WooCommerce\GoogleListingsAndAds\Vendor\Google\Service\ShoppingContent;

class OrderCustomer extends \Automattic\WooCommerce\GoogleListingsAndAds\Vendor\Google\Model
{
  /**
   * @var string
   */
  public $fullName;
  /**
   * @var string
   */
  public $invoiceReceivingEmail;
  protected $loyaltyInfoType = OrderCustomerLoyaltyInfo::class;
  protected $loyaltyInfoDataType = '';
  public $loyaltyInfo;
  protected $marketingRightsInfoType = OrderCustomerMarketingRightsInfo::class;
  protected $marketingRightsInfoDataType = '';
  public $marketingRightsInfo;

  /**
   * @param string
   */
  public function setFullName($fullName)
  {
    $this->fullName = $fullName;
  }
  /**
   * @return string
   */
  public function getFullName()
  {
    return $this->fullName;
  }
  /**
   * @param string
   */
  public function setInvoiceReceivingEmail($invoiceReceivingEmail)
  {
    $this->invoiceReceivingEmail = $invoiceReceivingEmail;
  }
  /**
   * @return string
   */
  public function getInvoiceReceivingEmail()
  {
    return $this->invoiceReceivingEmail;
  }
  /**
   * @param OrderCustomerLoyaltyInfo
   */
  public function setLoyaltyInfo(OrderCustomerLoyaltyInfo $loyaltyInfo)
  {
    $this->loyaltyInfo = $loyaltyInfo;
  }
  /**
   * @return OrderCustomerLoyaltyInfo
   */
  public function getLoyaltyInfo()
  {
    return $this->loyaltyInfo;
  }
  /**
   * @param OrderCustomerMarketingRightsInfo
   */
  public function setMarketingRightsInfo(OrderCustomerMarketingRightsInfo $marketingRightsInfo)
  {
    $this->marketingRightsInfo = $marketingRightsInfo;
  }
  /**
   * @return OrderCustomerMarketingRightsInfo
   */
  public function getMarketingRightsInfo()
  {
    return $this->marketingRightsInfo;
  }
}

// Adding a class alias for backwards compatibility with the previous class name.
class_alias(OrderCustomer::class, 'Google_Service_ShoppingContent_OrderCustomer');
