<?php
/*
 * Copyright 2014 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

namespace Automattic\WooCommerce\GoogleListingsAndAds\Vendor\Google\Service\ShoppingContent;

class UnitInvoiceAdditionalCharge extends \Automattic\WooCommerce\GoogleListingsAndAds\Vendor\Google\Model
{
  protected $additionalChargeAmountType = Amount::class;
  protected $additionalChargeAmountDataType = '';
  public $additionalChargeAmount;
  /**
   * @var string
   */
  public $type;

  /**
   * @param Amount
   */
  public function setAdditionalChargeAmount(Amount $additionalChargeAmount)
  {
    $this->additionalChargeAmount = $additionalChargeAmount;
  }
  /**
   * @return Amount
   */
  public function getAdditionalChargeAmount()
  {
    return $this->additionalChargeAmount;
  }
  /**
   * @param string
   */
  public function setType($type)
  {
    $this->type = $type;
  }
  /**
   * @return string
   */
  public function getType()
  {
    return $this->type;
  }
}

// Adding a class alias for backwards compatibility with the previous class name.
class_alias(UnitInvoiceAdditionalCharge::class, 'Google_Service_ShoppingContent_UnitInvoiceAdditionalCharge');
