<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/ads/googleads/v12/common/simulation.proto

namespace Google\Ads\GoogleAds\V12\Common;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Projected metrics for a specific bid modifier amount.
 *
 * Generated from protobuf message <code>google.ads.googleads.v12.common.BidModifierSimulationPoint</code>
 */
class BidModifierSimulationPoint extends \Google\Protobuf\Internal\Message
{
    /**
     * The simulated bid modifier upon which projected metrics are based.
     *
     * Generated from protobuf field <code>optional double bid_modifier = 15;</code>
     */
    protected $bid_modifier = null;
    /**
     * Projected number of biddable conversions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double biddable_conversions = 16;</code>
     */
    protected $biddable_conversions = null;
    /**
     * Projected total value of biddable conversions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double biddable_conversions_value = 17;</code>
     */
    protected $biddable_conversions_value = null;
    /**
     * Projected number of clicks.
     *
     * Generated from protobuf field <code>optional int64 clicks = 18;</code>
     */
    protected $clicks = null;
    /**
     * Projected cost in micros.
     *
     * Generated from protobuf field <code>optional int64 cost_micros = 19;</code>
     */
    protected $cost_micros = null;
    /**
     * Projected number of impressions.
     *
     * Generated from protobuf field <code>optional int64 impressions = 20;</code>
     */
    protected $impressions = null;
    /**
     * Projected number of top slot impressions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional int64 top_slot_impressions = 21;</code>
     */
    protected $top_slot_impressions = null;
    /**
     * Projected number of biddable conversions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double parent_biddable_conversions = 22;</code>
     */
    protected $parent_biddable_conversions = null;
    /**
     * Projected total value of biddable conversions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double parent_biddable_conversions_value = 23;</code>
     */
    protected $parent_biddable_conversions_value = null;
    /**
     * Projected number of clicks for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_clicks = 24;</code>
     */
    protected $parent_clicks = null;
    /**
     * Projected cost in micros for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_cost_micros = 25;</code>
     */
    protected $parent_cost_micros = null;
    /**
     * Projected number of impressions for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_impressions = 26;</code>
     */
    protected $parent_impressions = null;
    /**
     * Projected number of top slot impressions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional int64 parent_top_slot_impressions = 27;</code>
     */
    protected $parent_top_slot_impressions = null;
    /**
     * Projected minimum daily budget that must be available to the parent
     * resource to realize this simulation.
     *
     * Generated from protobuf field <code>optional int64 parent_required_budget_micros = 28;</code>
     */
    protected $parent_required_budget_micros = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type float $bid_modifier
     *           The simulated bid modifier upon which projected metrics are based.
     *     @type float $biddable_conversions
     *           Projected number of biddable conversions.
     *           Only search advertising channel type supports this field.
     *     @type float $biddable_conversions_value
     *           Projected total value of biddable conversions.
     *           Only search advertising channel type supports this field.
     *     @type int|string $clicks
     *           Projected number of clicks.
     *     @type int|string $cost_micros
     *           Projected cost in micros.
     *     @type int|string $impressions
     *           Projected number of impressions.
     *     @type int|string $top_slot_impressions
     *           Projected number of top slot impressions.
     *           Only search advertising channel type supports this field.
     *     @type float $parent_biddable_conversions
     *           Projected number of biddable conversions for the parent resource.
     *           Only search advertising channel type supports this field.
     *     @type float $parent_biddable_conversions_value
     *           Projected total value of biddable conversions for the parent resource.
     *           Only search advertising channel type supports this field.
     *     @type int|string $parent_clicks
     *           Projected number of clicks for the parent resource.
     *     @type int|string $parent_cost_micros
     *           Projected cost in micros for the parent resource.
     *     @type int|string $parent_impressions
     *           Projected number of impressions for the parent resource.
     *     @type int|string $parent_top_slot_impressions
     *           Projected number of top slot impressions for the parent resource.
     *           Only search advertising channel type supports this field.
     *     @type int|string $parent_required_budget_micros
     *           Projected minimum daily budget that must be available to the parent
     *           resource to realize this simulation.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Ads\GoogleAds\V12\Common\Simulation::initOnce();
        parent::__construct($data);
    }

    /**
     * The simulated bid modifier upon which projected metrics are based.
     *
     * Generated from protobuf field <code>optional double bid_modifier = 15;</code>
     * @return float
     */
    public function getBidModifier()
    {
        return isset($this->bid_modifier) ? $this->bid_modifier : 0.0;
    }

    public function hasBidModifier()
    {
        return isset($this->bid_modifier);
    }

    public function clearBidModifier()
    {
        unset($this->bid_modifier);
    }

    /**
     * The simulated bid modifier upon which projected metrics are based.
     *
     * Generated from protobuf field <code>optional double bid_modifier = 15;</code>
     * @param float $var
     * @return $this
     */
    public function setBidModifier($var)
    {
        GPBUtil::checkDouble($var);
        $this->bid_modifier = $var;

        return $this;
    }

    /**
     * Projected number of biddable conversions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double biddable_conversions = 16;</code>
     * @return float
     */
    public function getBiddableConversions()
    {
        return isset($this->biddable_conversions) ? $this->biddable_conversions : 0.0;
    }

    public function hasBiddableConversions()
    {
        return isset($this->biddable_conversions);
    }

    public function clearBiddableConversions()
    {
        unset($this->biddable_conversions);
    }

    /**
     * Projected number of biddable conversions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double biddable_conversions = 16;</code>
     * @param float $var
     * @return $this
     */
    public function setBiddableConversions($var)
    {
        GPBUtil::checkDouble($var);
        $this->biddable_conversions = $var;

        return $this;
    }

    /**
     * Projected total value of biddable conversions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double biddable_conversions_value = 17;</code>
     * @return float
     */
    public function getBiddableConversionsValue()
    {
        return isset($this->biddable_conversions_value) ? $this->biddable_conversions_value : 0.0;
    }

    public function hasBiddableConversionsValue()
    {
        return isset($this->biddable_conversions_value);
    }

    public function clearBiddableConversionsValue()
    {
        unset($this->biddable_conversions_value);
    }

    /**
     * Projected total value of biddable conversions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double biddable_conversions_value = 17;</code>
     * @param float $var
     * @return $this
     */
    public function setBiddableConversionsValue($var)
    {
        GPBUtil::checkDouble($var);
        $this->biddable_conversions_value = $var;

        return $this;
    }

    /**
     * Projected number of clicks.
     *
     * Generated from protobuf field <code>optional int64 clicks = 18;</code>
     * @return int|string
     */
    public function getClicks()
    {
        return isset($this->clicks) ? $this->clicks : 0;
    }

    public function hasClicks()
    {
        return isset($this->clicks);
    }

    public function clearClicks()
    {
        unset($this->clicks);
    }

    /**
     * Projected number of clicks.
     *
     * Generated from protobuf field <code>optional int64 clicks = 18;</code>
     * @param int|string $var
     * @return $this
     */
    public function setClicks($var)
    {
        GPBUtil::checkInt64($var);
        $this->clicks = $var;

        return $this;
    }

    /**
     * Projected cost in micros.
     *
     * Generated from protobuf field <code>optional int64 cost_micros = 19;</code>
     * @return int|string
     */
    public function getCostMicros()
    {
        return isset($this->cost_micros) ? $this->cost_micros : 0;
    }

    public function hasCostMicros()
    {
        return isset($this->cost_micros);
    }

    public function clearCostMicros()
    {
        unset($this->cost_micros);
    }

    /**
     * Projected cost in micros.
     *
     * Generated from protobuf field <code>optional int64 cost_micros = 19;</code>
     * @param int|string $var
     * @return $this
     */
    public function setCostMicros($var)
    {
        GPBUtil::checkInt64($var);
        $this->cost_micros = $var;

        return $this;
    }

    /**
     * Projected number of impressions.
     *
     * Generated from protobuf field <code>optional int64 impressions = 20;</code>
     * @return int|string
     */
    public function getImpressions()
    {
        return isset($this->impressions) ? $this->impressions : 0;
    }

    public function hasImpressions()
    {
        return isset($this->impressions);
    }

    public function clearImpressions()
    {
        unset($this->impressions);
    }

    /**
     * Projected number of impressions.
     *
     * Generated from protobuf field <code>optional int64 impressions = 20;</code>
     * @param int|string $var
     * @return $this
     */
    public function setImpressions($var)
    {
        GPBUtil::checkInt64($var);
        $this->impressions = $var;

        return $this;
    }

    /**
     * Projected number of top slot impressions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional int64 top_slot_impressions = 21;</code>
     * @return int|string
     */
    public function getTopSlotImpressions()
    {
        return isset($this->top_slot_impressions) ? $this->top_slot_impressions : 0;
    }

    public function hasTopSlotImpressions()
    {
        return isset($this->top_slot_impressions);
    }

    public function clearTopSlotImpressions()
    {
        unset($this->top_slot_impressions);
    }

    /**
     * Projected number of top slot impressions.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional int64 top_slot_impressions = 21;</code>
     * @param int|string $var
     * @return $this
     */
    public function setTopSlotImpressions($var)
    {
        GPBUtil::checkInt64($var);
        $this->top_slot_impressions = $var;

        return $this;
    }

    /**
     * Projected number of biddable conversions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double parent_biddable_conversions = 22;</code>
     * @return float
     */
    public function getParentBiddableConversions()
    {
        return isset($this->parent_biddable_conversions) ? $this->parent_biddable_conversions : 0.0;
    }

    public function hasParentBiddableConversions()
    {
        return isset($this->parent_biddable_conversions);
    }

    public function clearParentBiddableConversions()
    {
        unset($this->parent_biddable_conversions);
    }

    /**
     * Projected number of biddable conversions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double parent_biddable_conversions = 22;</code>
     * @param float $var
     * @return $this
     */
    public function setParentBiddableConversions($var)
    {
        GPBUtil::checkDouble($var);
        $this->parent_biddable_conversions = $var;

        return $this;
    }

    /**
     * Projected total value of biddable conversions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double parent_biddable_conversions_value = 23;</code>
     * @return float
     */
    public function getParentBiddableConversionsValue()
    {
        return isset($this->parent_biddable_conversions_value) ? $this->parent_biddable_conversions_value : 0.0;
    }

    public function hasParentBiddableConversionsValue()
    {
        return isset($this->parent_biddable_conversions_value);
    }

    public function clearParentBiddableConversionsValue()
    {
        unset($this->parent_biddable_conversions_value);
    }

    /**
     * Projected total value of biddable conversions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional double parent_biddable_conversions_value = 23;</code>
     * @param float $var
     * @return $this
     */
    public function setParentBiddableConversionsValue($var)
    {
        GPBUtil::checkDouble($var);
        $this->parent_biddable_conversions_value = $var;

        return $this;
    }

    /**
     * Projected number of clicks for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_clicks = 24;</code>
     * @return int|string
     */
    public function getParentClicks()
    {
        return isset($this->parent_clicks) ? $this->parent_clicks : 0;
    }

    public function hasParentClicks()
    {
        return isset($this->parent_clicks);
    }

    public function clearParentClicks()
    {
        unset($this->parent_clicks);
    }

    /**
     * Projected number of clicks for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_clicks = 24;</code>
     * @param int|string $var
     * @return $this
     */
    public function setParentClicks($var)
    {
        GPBUtil::checkInt64($var);
        $this->parent_clicks = $var;

        return $this;
    }

    /**
     * Projected cost in micros for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_cost_micros = 25;</code>
     * @return int|string
     */
    public function getParentCostMicros()
    {
        return isset($this->parent_cost_micros) ? $this->parent_cost_micros : 0;
    }

    public function hasParentCostMicros()
    {
        return isset($this->parent_cost_micros);
    }

    public function clearParentCostMicros()
    {
        unset($this->parent_cost_micros);
    }

    /**
     * Projected cost in micros for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_cost_micros = 25;</code>
     * @param int|string $var
     * @return $this
     */
    public function setParentCostMicros($var)
    {
        GPBUtil::checkInt64($var);
        $this->parent_cost_micros = $var;

        return $this;
    }

    /**
     * Projected number of impressions for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_impressions = 26;</code>
     * @return int|string
     */
    public function getParentImpressions()
    {
        return isset($this->parent_impressions) ? $this->parent_impressions : 0;
    }

    public function hasParentImpressions()
    {
        return isset($this->parent_impressions);
    }

    public function clearParentImpressions()
    {
        unset($this->parent_impressions);
    }

    /**
     * Projected number of impressions for the parent resource.
     *
     * Generated from protobuf field <code>optional int64 parent_impressions = 26;</code>
     * @param int|string $var
     * @return $this
     */
    public function setParentImpressions($var)
    {
        GPBUtil::checkInt64($var);
        $this->parent_impressions = $var;

        return $this;
    }

    /**
     * Projected number of top slot impressions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional int64 parent_top_slot_impressions = 27;</code>
     * @return int|string
     */
    public function getParentTopSlotImpressions()
    {
        return isset($this->parent_top_slot_impressions) ? $this->parent_top_slot_impressions : 0;
    }

    public function hasParentTopSlotImpressions()
    {
        return isset($this->parent_top_slot_impressions);
    }

    public function clearParentTopSlotImpressions()
    {
        unset($this->parent_top_slot_impressions);
    }

    /**
     * Projected number of top slot impressions for the parent resource.
     * Only search advertising channel type supports this field.
     *
     * Generated from protobuf field <code>optional int64 parent_top_slot_impressions = 27;</code>
     * @param int|string $var
     * @return $this
     */
    public function setParentTopSlotImpressions($var)
    {
        GPBUtil::checkInt64($var);
        $this->parent_top_slot_impressions = $var;

        return $this;
    }

    /**
     * Projected minimum daily budget that must be available to the parent
     * resource to realize this simulation.
     *
     * Generated from protobuf field <code>optional int64 parent_required_budget_micros = 28;</code>
     * @return int|string
     */
    public function getParentRequiredBudgetMicros()
    {
        return isset($this->parent_required_budget_micros) ? $this->parent_required_budget_micros : 0;
    }

    public function hasParentRequiredBudgetMicros()
    {
        return isset($this->parent_required_budget_micros);
    }

    public function clearParentRequiredBudgetMicros()
    {
        unset($this->parent_required_budget_micros);
    }

    /**
     * Projected minimum daily budget that must be available to the parent
     * resource to realize this simulation.
     *
     * Generated from protobuf field <code>optional int64 parent_required_budget_micros = 28;</code>
     * @param int|string $var
     * @return $this
     */
    public function setParentRequiredBudgetMicros($var)
    {
        GPBUtil::checkInt64($var);
        $this->parent_required_budget_micros = $var;

        return $this;
    }

}

